/*
 * lxcall-a.h.c
 * Copyright (C) 2011-2014, 2016, 2017, 2019, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <frame.h>
#include <lxcall-types.h>

int
_libx1f4i0_lxcall_near_call(struct covert_type *covert_data)
{
    int status;

    if (covert_data->swap) {
	struct x1f4_scope_type *scope_data;

	scope_data = covert_data->scope_data;
	status = scope_data->swap
	    (covert_data->swap, covert_data->frame_data->data);
	if (status) {
	}
	status = scope_data->fini(&covert_data->swap, scope_data->data);
	if (status) {
	}
    } else {
	status = 0;
    }

    return status;
}
