/*
 * lxdash-d.s.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <d_fset.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_s_derived(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data, *dxdash_text;
    unsigned size;

    dxdash_data = I_LINE(input[0]);
    dxdash_text = I_LINE(input[2]);

    size = dxdash_data->size;

    if (0) {
    } else {
	struct effect_type effect;
	void *dxtext;

	effect.mode = I_MODE(input[1]);

	status = _libx1f4i0_lxdash_line_line(context, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_tear_lxfset
		(dxdash_data->dash, &effect, 0,
		 ((struct dxdash_type *) dxtext)->dash);
	    if (status) {
	    } else {
		void *way_red[4];

		way_red[1] = context;
		way_red[2] = lock_excase(dxdash_data);
		way_red[3] = lock_excase(dxdash_text);

		status = _libx1f4i0_lime_lxfset
		    (((struct dxdash_type *) dxtext)->dash, way_red,
		     _libx1f4i0_lxdash_move_dash);
		if (status) {
		} else {
		    unsigned call;

		    _libx1f4i0_size_lxfset(dxdash_data->dash, &call);
		    dxdash_data->size = call;
		    ((struct dxdash_type *) dxtext)->size = size - call;

		    status = _libx1f4i0_lxdash_swap_line(dxtext, dxdash_text);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxdash_flat_line(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    if (status) {
    } else {
	l_LINE(dxdash_data, output);
    }

    return status;
}
