/*
 * lxdash-p.i.c
 * Copyright (C) 2008-2013, 2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define byte(miss)			((unsigned char *) (miss))

#define dxdash(line) \
    ((struct dxdash_type *) (line))

int
_libx1f4i0_lxdash_i_pending(void *context, void *output, void **input)
{
    int status;
    struct effect_type effect;
    void *data;

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset
	(dxdash(I_LINE(input[0]))->dash, &effect, &data);
    if (status) {
	l_MODE(((struct effect_type *) data)->type, output);

	status = 0;
    } else {
	status = _libx1f4i0_lxdash_stat_miss(context, effect.mode);
    }

    return status;
}
