/*
 * lxdata-d.g-a.c
 * Copyright (C) 2008-2011, 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-drive.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_gaderived(void *context, void *output, void **input)
{
    char *d, *t;
    int delete;
    struct dxdata_type *dxdata_data;

    dxdata_data = I_DATA(input[0]);

    t = I_TEXT(input[1]);

    d = dxdata_data->string;

    while (1) {
	unsigned char c, e;

	c = *(unsigned char *) t++;
	if (c ^ (e = *(unsigned char *) d++)) {
	    delete = c < e;

	    break;
	} else {
	    if (c) {
	    } else {
		delete = t - I_TEXT(input[1]) < dxdata_data->length + 1;

		break;
	    }
	}
    }

    l_MODE(delete, output);

    return 0;
}
