/*
 * lxpoll-a.d.c
 * Copyright (C) 2008-2010, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxpoll-types.h>

#define lxpoll(lxpoll) \
    ((struct lxpoll_type *) (lxpoll))

int
x1f4_cfix_lxpoll(void *lxpoll, unsigned index, void *context)
{
    struct lxtext_type *lxtext_data;

    lxtext_data = lxpoll(lxpoll)->link_f.text;
    index++;
    lxtext_data += index;
    lxtext_data->text = context;

    if (lxtext_data == lxpoll(lxpoll)->link_k.date) {
	lxpoll(lxpoll)->link_k.lxdate = context;
    } else {
	if (lxtext_data == lxpoll(lxpoll)->link_k.file) {
	    lxpoll(lxpoll)->link_k.lxfile = context;
	} else {
	}
    }

    return 0;
}
