/*
 * a12nd.9.c
 * Copyright (C) 2008, 2009, 2013, 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-types.h>
#include <trans.h>

int
_x1f4_a1_miss_slip(struct a1_node_type *node_data)
{
    int (*free)(void *, void *), status = 0;
    struct a1_link_type *link_data;
    unsigned count, i;
    void *data;

    count = node_data->linetext.function.count;

    link_data = node_data->link_data;

    data = node_data->grid_data->trans.data;
    free = node_data->grid_data->trans.free;

    if (1) {
	i = count;
	for (; i; i--) {
	    int excess;

	    excess = free(data, (void *) link_data->variable.name);
	    if (excess) {
		if (status) {
		} else {
		    status = excess;
		}
	    }

	    link_data++;
	}

	if (1) {
	    int excess;

	    excess = free(data, link_data - count);
	    if (excess) {
		if (status) {
		} else {
		    status = excess;
		}
	    }
	}
    }

    return status;
}
