/*
 * e4fine.4.c
 * Copyright (C) 2008-2012, 2014, 2017, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <e4fine.h>

int
x1f4_void_e4fine(void *e4fine, int outer, int inner)
{
    int delete = 0;
    const struct x1f4_linetext_type *linetext_data;

    if (x1f4_pick_e4fine(e4fine, inner, &linetext_data)) {
	int lapse;
	struct x1f4_linetext_type linetext;

	linetext = *linetext_data;
	linetext.function.type = X1f4_E4_VOID;
	if (x1f4_type_e4fine(e4fine, &lapse, &linetext)) {
	} else {
	    if (lapse == outer) {
		delete = 1;
	    }
	}
    }

    return delete;
}
