/*
 * lxdash-a.q.c
 * Copyright (C) 2008-2013, 2015, 2017, 2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_down_line(void *subtext, void *excase, void *dxdash)
{
    int status;
    void *way_red[4];

    way_red[1] = subtext;
    way_red[2] = excase;
    way_red[3] = lock_excase(dxdash);

    status = _libx1f4i0_lime_lxfset
	(((const struct dxdash_type *) dxdash)->dash, way_red,
	 _libx1f4i0_lxdash_move_dash);

    return status;
}
