/*
 * lxdate-l.r.c
 * Copyright (C) 2020, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdate-drive.h>
#include <lxdate-types.h>

int
_libx1f4i0_lxdate_r_logique(void *context, void *output, void **input)
{
    struct dxdate_type *dxdate_data;

    dxdate_data = I_DATE(input[0]);

    l_REAL(dxdate_data->time + (double) dxdate_data->second_f / 1000000,
	   output);

    return 0;
}
