/*
 * lxline-a.q.c
 * Copyright (C) 2008-2013, 2017, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l_note.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_down_line(void *subtext, void *excase, void *dxline)
{
    int status;
    void *way_red[4];

    way_red[1] = subtext;
    way_red[2] = excase;
    way_red[3] = lock_excase(dxline);

    status = _libx1f4i0_lime_sfnote
	(((const struct dxline_type *) dxline)->line, way_red,
	 _libx1f4i0_lxrail_move_rail);

    return status;
}
