/*
 * lxlist-d.r.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_r_derived(void *context, void *output, void **input)
{
    struct dxlist_type *dxlist_data;

    dxlist_data = I_LIST(input[0]);

    _libx1f4i0_rand_l4list(dxlist_data->list);

    l_LIST(dxlist_data, output);

    return 0;
}
