/*
 * lxlong-types.h
 * Copyright (C) 2016, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxlong_H__
#define __LIBx1f4_lxlong_H__

#include <e4.h>
#include <lxlock.h>

typedef struct lxlong_type {
    struct lxlock_type ever_a;
    struct {
	void *data, *rate, *side, *text;
    } link_f;
    struct {
	const struct x1f4_eelookup_type *eelookup_data;
    } trap_e;
} lxlong_type;

#endif				/* __LIBx1f4_lxlong_H__ */
