/*
 * lxmath-k.b.c
 * Copyright (C) 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxmath-drive.h>

int
_libx1f4i0_lxmath_k171228_3(void *context, void *output, void **input)
{
    X1f4_E4_C_BILL side;

    side = I_BILL(input[0]) - I_BILL(input[1]);

    l_BILL(side, output);
    l_BILL(side, input[0]);

    return 0;
}


int
_libx1f4i0_lxmath_k171228_4(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE side;

    side = I_MODE(input[0]) - I_MODE(input[1]);

    l_MODE(side, output);
    l_MODE(side, input[0]);

    return 0;
}


int
_libx1f4i0_lxmath_k171228_5(void *context, void *output, void **input)
{
    X1f4_E4_C_REAL side;

    side = I_REAL(input[0]) - I_REAL(input[1]);

    l_REAL(side, output);
    l_REAL(side, input[0]);

    return 0;
}
