/*
 * lxvery-d.s.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxvery-config.h>

#include <e4.h>
#include <d_fset.h>
#include <lxcall.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

int
_libx1f4i0_lxvery_s_derived(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE very;
    int status;
    struct dxvery_type *dxvery_data, *dxvery_text;
    unsigned size;

    dxvery_data = I_LINE(input[0]);
    dxvery_text = I_LINE(input[2]);

    size = dxvery_data->size;

    very = I_MODE(input[1]);
#if __VERY_PSET__
    very += ~(X1f4_E4_C_BILL) 0 >> 1;
#endif				/* __VERY_PSET__ */

    if (0) {
    } else {
	void *dxtext;

	status = _libx1f4i0_lxvery_line_line(context, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_tear_lxfset
		(dxvery_data->dash, &very, 0,
		 ((struct dxvery_type *) dxtext)->dash);
	    if (status) {
	    } else {
		if (0) {
		} else {
		    unsigned call;

		    _libx1f4i0_size_lxfset(dxvery_data->dash, &call);
		    dxvery_data->size = call;
		    ((struct dxvery_type *) dxtext)->size = size - call;

		    status = _libx1f4i0_lxvery_swap_line(dxtext, dxvery_text);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxvery_flat_line(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    if (status) {
    } else {
	l_LINE(dxvery_data, output);
    }

    return status;
}
